Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 5707)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 5874)
@@ -29,5 +29,5 @@
 		ConfigMerger.exe = ConfigMerger.exe
 		HeuristicLab 3.3.vsmdi = HeuristicLab 3.3.vsmdi
-		HeuristicLab.Hive 3.32.vsmdi = HeuristicLab.Hive 3.32.vsmdi
+		HeuristicLab.Hive 3.3.vsmdi = HeuristicLab.Hive 3.3.vsmdi
 		LocalTestRun.testrunconfig = LocalTestRun.testrunconfig
 		PreBuildEvent.cmd = PreBuildEvent.cmd
@@ -108,5 +108,5 @@
 Global
 	GlobalSection(TestCaseManagementSettings) = postSolution
-		CategoryFile = HeuristicLab.Hive 3.32.vsmdi
+		CategoryFile = HeuristicLab.Hive 3.3.vsmdi
 	EndGlobalSection
 	GlobalSection(SolutionConfigurationPlatforms) = preSolution
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/DisposableWrapper.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/DisposableWrapper.cs	(revision 5874)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/DisposableWrapper.cs	(revision 5874)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Hive.Contracts {
+  public class DisposableWrapper : IDisposable {
+    protected object obj;
+    public object Obj {
+      get { return obj; }
+    }
+
+    public DisposableWrapper(object obj) {
+      this.obj = obj;
+    }
+
+    public void Dispose() {
+      if (OnDisposing != null)
+        OnDisposing(this, new EventArgs<object>(obj));
+    }
+
+    public event EventHandler<EventArgs<object>> OnDisposing;
+  }
+
+  public sealed class DisposableWrapper<T> : DisposableWrapper {
+    public new T Obj {
+      get { return (T)base.obj; }
+    }
+
+    public DisposableWrapper(T obj) : base(obj) { }
+  }
+}
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.Designer.cs	(revision 5707)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.Designer.cs	(revision 5874)
@@ -82,8 +82,4 @@
       this.nameTextBox.Size = new System.Drawing.Size(663, 20);
       // 
-      // descriptionTextBox
-      // 
-      this.descriptionTextBox.Size = new System.Drawing.Size(663, 20);
-      // 
       // tabControl
       // 
@@ -145,5 +141,5 @@
       this.experimentNamedItemView.Name = "experimentNamedItemView";
       this.experimentNamedItemView.ReadOnly = false;
-      this.experimentNamedItemView.Size = new System.Drawing.Size(721, 52);
+      this.experimentNamedItemView.Size = new System.Drawing.Size(721, 22);
       this.experimentNamedItemView.TabIndex = 3;
       // 
@@ -152,5 +148,5 @@
       this.viewExperimentButton.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      this.viewExperimentButton.Location = new System.Drawing.Point(0, 94);
+      this.viewExperimentButton.Location = new System.Drawing.Point(0, 64);
       this.viewExperimentButton.Name = "viewExperimentButton";
       this.viewExperimentButton.Size = new System.Drawing.Size(727, 23);
@@ -361,4 +357,5 @@
       this.Name = "HiveExperimentView";
       this.Size = new System.Drawing.Size(735, 524);
+      this.Controls.SetChildIndex(this.infoLabel, 0);
       this.Controls.SetChildIndex(this.reconnectButton, 0);
       this.Controls.SetChildIndex(this.resetButton, 0);
@@ -373,7 +370,5 @@
       this.Controls.SetChildIndex(this.tabControl, 0);
       this.Controls.SetChildIndex(this.nameLabel, 0);
-      this.Controls.SetChildIndex(this.descriptionLabel, 0);
       this.Controls.SetChildIndex(this.nameTextBox, 0);
-      this.Controls.SetChildIndex(this.descriptionTextBox, 0);
       this.Controls.SetChildIndex(this.downloadExperimentPanel, 0);
       ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.cs	(revision 5707)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.cs	(revision 5874)
@@ -101,5 +101,4 @@
       if (Content != null) {
         this.nameTextBox.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
-        this.descriptionTextBox.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
         this.resourceIdsTextBox.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
         this.hiveJobView.ReadOnly = Content.ExecutionState != ExecutionState.Prepared;
@@ -132,5 +131,5 @@
         Invoke(new EventHandler(Content_Prepared), sender, e);
       else {
-        nameTextBox.Enabled = descriptionTextBox.Enabled = true;
+        nameTextBox.Enabled = true;
         Locked = false;
         SetEnabledStateOfControls();
@@ -141,5 +140,5 @@
         Invoke(new EventHandler(Content_Started), sender, e);
       else {
-        nameTextBox.Enabled = descriptionTextBox.Enabled = false;
+        nameTextBox.Enabled = false;
         SetEnabledStateOfControls();
       }
@@ -149,5 +148,5 @@
         Invoke(new EventHandler(Content_Paused), sender, e);
       else {
-        nameTextBox.Enabled = descriptionTextBox.Enabled = true;
+        nameTextBox.Enabled = true;
         SetEnabledStateOfControls();
       }
@@ -157,5 +156,5 @@
         Invoke(new EventHandler(Content_Stopped), sender, e);
       else {
-        nameTextBox.Enabled = descriptionTextBox.Enabled = true;
+        nameTextBox.Enabled = true;
         Locked = false;
         SetEnabledStateOfControls();
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.resx
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.resx	(revision 5707)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveExperimentView.resx	(revision 5874)
@@ -113,16 +113,16 @@
   </resheader>
   <resheader name="reader">
-    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
   <resheader name="writer">
-    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
-  </resheader>
-  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <metadata name="errorProvider.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>107, 17</value>
   </metadata>
-  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
+  <metadata name="toolTip.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
     <value>17, 17</value>
   </metadata>
-  <assembly alias="System.Drawing" name="System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+  <assembly alias="System.Drawing" name="System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
   <data name="openExperimentButton.Image" type="System.Drawing.Bitmap, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
     <value>
@@ -204,5 +204,5 @@
         fNTws+7PbaOWo6fHXMf6Hwc/vj/OGn/2S8Yv7ycKnpCfVEyqTDZPmU2dmnafvvF05dOJZ+nPFmYKf5X+
         tfa5zvMffnP8rX82YnbiBf/Fp99LXsq/PPRq2aueuYC5R69TXy/MF72Rf3P4LeNt37vwd5MLWe+x7ys/
-        6H7o/ujz8cGn1E+f/gUDmPP8usTo0wAAAAlwSFlzAAAOvQAADr0BR/uQrQAAA2JJREFUOE9lk31MFHQY
+        6H7o/ujz8cGn1E+f/gUDmPP8usTo0wAAAAlwSFlzAAAOvAAADrwBlbxySQAAA2JJREFUOE9lk31MFHQY
         x59JZIU62/QPF1gauDJXjkpyZLxVMEEubgpKU0NePKS6yp168qaJ4OIlMhUH6hRWChyuuuTaQjqFk8j0
         MEhlURdMRgp0XERccfjpx7G1Vn8822+/fb/fz/f54xFA/jtDf03S4fyTloE/6PhlFNfvY0xMTCjZ/7X/
@@ -268,5 +268,5 @@
 </value>
   </data>
-  <metadata name="$this.TrayHeight" type="System.Int32, mscorlib, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
+  <metadata name="$this.TrayHeight" type="System.Int32, mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089">
     <value>25</value>
   </metadata>
Index: branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveJobView.Designer.cs
===================================================================
--- branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveJobView.Designer.cs	(revision 5707)
+++ branches/HeuristicLab.Hive-3.3/sources/HeuristicLab.Hive/HeuristicLab.Hive.ExperimentManager.Views/3.3/HiveJobView.Designer.cs	(revision 5874)
@@ -193,5 +193,5 @@
       this.jobStatusGroupBox.Controls.Add(this.dateFinishedLabel);
       this.jobStatusGroupBox.Controls.Add(this.exceptionTextBox);
-      this.jobStatusGroupBox.Location = new System.Drawing.Point(6, 226);
+      this.jobStatusGroupBox.Location = new System.Drawing.Point(6, 203);
       this.jobStatusGroupBox.Name = "jobStatusGroupBox";
       this.jobStatusGroupBox.Size = new System.Drawing.Size(610, 162);
@@ -237,5 +237,5 @@
       this.optimizerGroupBox.Location = new System.Drawing.Point(6, 29);
       this.optimizerGroupBox.Name = "optimizerGroupBox";
-      this.optimizerGroupBox.Size = new System.Drawing.Size(610, 74);
+      this.optimizerGroupBox.Size = new System.Drawing.Size(610, 47);
       this.optimizerGroupBox.TabIndex = 28;
       this.optimizerGroupBox.TabStop = false;
@@ -251,5 +251,5 @@
       this.optimizerNamedItemView.Name = "optimizerNamedItemView";
       this.optimizerNamedItemView.ReadOnly = false;
-      this.optimizerNamedItemView.Size = new System.Drawing.Size(604, 51);
+      this.optimizerNamedItemView.Size = new System.Drawing.Size(604, 21);
       this.optimizerNamedItemView.TabIndex = 0;
       // 
@@ -266,5 +266,5 @@
       this.configurationGroupBox.Controls.Add(this.computeInParallelLabel);
       this.configurationGroupBox.Controls.Add(this.computeInParallelCheckBox);
-      this.configurationGroupBox.Location = new System.Drawing.Point(6, 105);
+      this.configurationGroupBox.Location = new System.Drawing.Point(6, 82);
       this.configurationGroupBox.Name = "configurationGroupBox";
       this.configurationGroupBox.Size = new System.Drawing.Size(610, 119);