Index: /trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd
===================================================================
--- /trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLab 3.3 Plugin Template/InstallTemplate.cmd	(revision 5878)
@@ -1,4 +1,3 @@
 SET ZIPFILENAME=HeuristicLab 3.3 Plugin Template.zip
-REM "%ProgramFiles%\7-Zip\7z" a "%ZIPFILENAME%" AssemblyInfo.cs AssemblyInfo.frame HeuristicLab.Plugin.csproj HeuristicLab.snk HeuristicLabIcon.ico Plugin.cs Plugin.cs.frame PluginProjectTemplate.vstemplate
 "%ProgramFiles%\7-Zip\7z" a "%ZIPFILENAME%" 3.3 HeuristicLabIcon.ico PluginProjectCollectionTemplate.vstemplate
 copy "%ZIPFILENAME%" "%UserProfile%\Documents\Visual Studio 2010\Templates\ProjectTemplates\Visual C#\"
Index: /trunk/tools/Templates/HeuristicLab.VS2010Wizards/ProblemWizardForm.cs
===================================================================
--- /trunk/tools/Templates/HeuristicLab.VS2010Wizards/ProblemWizardForm.cs	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLab.VS2010Wizards/ProblemWizardForm.cs	(revision 5878)
@@ -76,7 +76,7 @@
 
       if (IsSingleObjective) {
-        ProblemTypeImplementation = "SingleObjectiveProblem<" + EvaluatorType + ", " + SolutionCreatorType + ">";
+        ProblemTypeImplementation = "SingleObjectiveHeuristicOptimizationProblem<" + EvaluatorType + ", " + SolutionCreatorType + ">";
       } else if (IsMultiObjective) {
-        ProblemTypeImplementation = "MultiObjectiveProblem<" + EvaluatorType + ", " + SolutionCreatorType + ">";
+        ProblemTypeImplementation = "MultiObjectiveHeuristicOptimizationProblem<" + EvaluatorType + ", " + SolutionCreatorType + ">";
       }
     }
Index: /trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/AssemblyInfo.cs
===================================================================
--- /trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/AssemblyInfo.cs	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLab.VS2010Wizards/Properties/AssemblyInfo.cs	(revision 5878)
@@ -32,4 +32,4 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.3.1")]
-[assembly: AssemblyFileVersion("3.3.3.1")]
+[assembly: AssemblyVersion("3.3.3.2")]
+[assembly: AssemblyFileVersion("3.3.3.2")]
Index: /trunk/tools/Templates/HeuristicLabAlgorithmTemplate/MyTemplate.vstemplate
===================================================================
--- /trunk/tools/Templates/HeuristicLabAlgorithmTemplate/MyTemplate.vstemplate	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLabAlgorithmTemplate/MyTemplate.vstemplate	(revision 5878)
@@ -13,5 +13,5 @@
   </TemplateContent>
   <WizardExtension>
-    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.1, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
+    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.2, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
     <FullClassName>HeuristicLab.VS2010Wizards.AlgorithmWizard</FullClassName>
   </WizardExtension>
Index: /trunk/tools/Templates/HeuristicLabItemTemplate/MyTemplate.vstemplate
===================================================================
--- /trunk/tools/Templates/HeuristicLabItemTemplate/MyTemplate.vstemplate	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLabItemTemplate/MyTemplate.vstemplate	(revision 5878)
@@ -13,5 +13,5 @@
   </TemplateContent>
   <WizardExtension>
-    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.1, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
+    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.2, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
     <FullClassName>HeuristicLab.VS2010Wizards.ItemWizard</FullClassName>
   </WizardExtension>
Index: /trunk/tools/Templates/HeuristicLabProblemTemplate/MyTemplate.vstemplate
===================================================================
--- /trunk/tools/Templates/HeuristicLabProblemTemplate/MyTemplate.vstemplate	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLabProblemTemplate/MyTemplate.vstemplate	(revision 5878)
@@ -13,5 +13,5 @@
   </TemplateContent>
   <WizardExtension>
-    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.1, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
+    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.2, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
     <FullClassName>HeuristicLab.VS2010Wizards.ProblemWizard</FullClassName>
   </WizardExtension>
Index: /trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj
===================================================================
--- /trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLabVS2010WizardsInstaller/HeuristicLabVS2010WizardsInstaller.vdproj	(revision 5878)
@@ -573,13 +573,13 @@
         "ProductName" = "8:HeuristicLab 3.3 VS2010 Wizards"
         "ProductCode" = "8:{B99828C4-2D65-461D-B13C-CAB57EAB6AC1}"
-        "PackageCode" = "8:{BAE7C376-6630-4965-ADD0-80719F63615E}"
+        "PackageCode" = "8:{67E2A85D-1C77-4CE3-B582-5D153801B98D}"
         "UpgradeCode" = "8:{3AF928E8-1C64-4A5A-BC16-44CD128F21D3}"
         "AspNetVersion" = "8:4.0.30319.0"
         "RestartWWWService" = "11:FALSE"
-        "RemovePreviousVersions" = "11:FALSE"
+        "RemovePreviousVersions" = "11:TRUE"
         "DetectNewerInstalledVersion" = "11:TRUE"
-        "InstallAllUsers" = "11:FALSE"
+        "InstallAllUsers" = "11:TRUE"
         "ProductVersion" = "8:1.0.0"
-        "Manufacturer" = "8:Microsoft"
+        "Manufacturer" = "8:HEAL"
         "ARPHELPTELEPHONE" = "8:"
         "ARPHELPLINK" = "8:"
@@ -1037,5 +1037,5 @@
             "{5259A561-127C-4D43-A0A1-72F10C7B3BF8}:_B51E170D986C45DD9BBEEC6B70686DC9"
             {
-            "SourcePath" = "8:..\\HeuristicLab.VS2010Wizards\\obj\\x86\\Debug\\HeuristicLab.VS2010Wizards.dll"
+            "SourcePath" = "8:..\\HeuristicLab.VS2010Wizards\\obj\\x86\\Release\\HeuristicLab.VS2010Wizards.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
Index: /trunk/tools/Templates/HeuristicLabViewTemplate/MyTemplate.vstemplate
===================================================================
--- /trunk/tools/Templates/HeuristicLabViewTemplate/MyTemplate.vstemplate	(revision 5877)
+++ /trunk/tools/Templates/HeuristicLabViewTemplate/MyTemplate.vstemplate	(revision 5878)
@@ -14,5 +14,5 @@
   </TemplateContent>
   <WizardExtension>
-    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.1, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
+    <Assembly>HeuristicLab.VS2010Wizards, Version=3.3.3.2, Culture=Neutral, PublicKeyToken=18a43a5d25a3c148</Assembly>
     <FullClassName>HeuristicLab.VS2010Wizards.ViewWizard</FullClassName>
   </WizardExtension>